

# 								热补丁增量及回滚测试

| 贡献者 | 江秀杰，许平       |
| ------ | ------------------ |
| 日期   | 2022/12/29         |
| 描述   | 4.19内核热补丁测试 |
| 审核   |                    |



## 功能说明

该模块非真实功能，旨在演示热补丁的增量回滚功能，通过多次修改同一个函数，达到增量演示功能。通过卸载修改了同一个函数的热补丁，达到回滚测试效果。安装的如本示例修改内核默认cmdline参数,查看原来的参数如下:

```
[root@localhost rpmbuild]# cat /proc/cmdline 
root=/dev/mapper/klas-root ro rd.lvm.lv=klas/root rd.lvm.lv=klas/swap rhgb console=ttyS0,115200 ignore_loglevel crashkernel=164M@64M rd_start=0x90000000f86c0000 rd_size=0x2af5277

```

打补丁1成功后，效果如下:

```
[root@localhost rpmbuild]# cat /proc/cmdline 
this has been live patched
```

打补丁2成功后，效果如下：

```
[root@localhost rpmbuild]# cat /proc/cmdline 
THIS HAS BEEN LIVE PATCHED
```



## 功能演示

​	以下：**xxx: 名字依赖具体平台**



### 1. 编译生成热补丁示例模块

分别进入rpmbuild1，rpmbuild2 编译出rpm包测试文件

```
[root@localhost rpmbuild]# cd  rpmbuild1
[root@localhost rpmbuild]# rpmbuild -ba -D  "_topdir `pwd`"  SPECS/livepatch.spec --nodebuginfo
[root@localhost rpmbuild]# cd  rpmbuild2
[root@localhost rpmbuild]# rpmbuild -ba -D  "_topdir `pwd`"  SPECS/livepatch.spec --nodebuginfo
```

### 2. 安装热补丁模块1

```
[root@localhost rpmbuild]# cd  rpmbuild1
[root@localhost rpmbuild]# rpm -ivh RPMS/`uname -m`/livepatch-sample1-xxx.rpm
```

### 3. 查看已安装热补丁模块

```
[root@localhost rpmbuild]# cat /proc/livepatch/state 
Index	Patch                     	State   
-----------------------------------------------
1    	livepatch_sample1          	enabled 
-----------------------------------------------
```

### 4. 检查热补丁模块1是否成功

```
[root@localhost rpmbuild]# cat /proc/cmdline 
this has been live patched
```

此为热补丁模块1生效

### 5.安装热补丁模块2 

```
[root@localhost rpmbuild]# cd  rpmbuild2
[root@localhost rpmbuild]# rpm -ivh RPMS/`uname -m`/livepatch-sample2-xxx.rpm（xxx为具体架构）

```

### 6.检查热补丁模块2是否成功

```
[root@localhost rpmbuild]# cat /proc/cmdline 
THIS HAS BEEN LIVE PATCHED
```

### 7..查看已安装热补丁模块

```
[root@localhost rpmbuild]# cat /proc/livepatch/state 
Index	Patch                     	State 
-----------------------------------------------
1    	livepatch_sample1          	enabled 
2    	livepatch_sample2          	enabled 
-----------------------------------------------
```

### 8. 回滚测试:卸载热补丁模块2

```
[root@localhost rpmbuild]# rpm -e livepatch-sample2-xxx.rpm
```

### 9. 检查模块是否已经卸载

```
[root@localhost rpmbuild]# cat /proc/livepatch/state 
Index	Patch                     	State   
-----------------------------------------------
1    	livepatch_sample          	enabled
-----------------------------------------------
[root@localhost rpmbuild]# cat /proc/cmdline 
this has been live patched

```
已经回滚到安装第一个热补丁时显示的内容
### 10.卸载热补丁模块1

```
[root@localhost rpmbuild]# rpm -e livepatch-sample2-xxx.rpm
-----------------------------------------------

-----------------------------------------------

回滚到了未打补丁时显示的内容
[root@localhost rpmbuild]# cat /proc/cmdline 
root=/dev/mapper/klas-root ro rd.lvm.lv=klas/root rd.lvm.lv=klas/swap rhgb console=ttyS0,115200 ignore_loglevel crashkernel=164M@64M rd_start=0x90000000f86c0000 rd_size=0x2af5277
```

热补丁增量回滚测试完成。
